/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { fetchEncodedAccount, fetchEncodedAccounts, type Account, type Address, type Codec, type Decoder, type EncodedAccount, type Encoder, type FetchAccountConfig, type FetchAccountsConfig, type MaybeAccount, type MaybeEncodedAccount, type ReadonlyUint8Array } from '@solana/web3.js';
import { MintProofV2Seeds } from '../pdas';
export type MintProofV2 = {
    discriminator: ReadonlyUint8Array;
    /** Length of proof without padding. */
    proofLen: number;
    /** Proof that the mint is part of the Merkle tree. */
    proof: Array<ReadonlyUint8Array>;
    /** Slot the proof was created. */
    creationSlot: bigint;
    /** The account that paid for creation of the proof. */
    payer: Address;
};
export type MintProofV2Args = {
    /** Length of proof without padding. */
    proofLen: number;
    /** Proof that the mint is part of the Merkle tree. */
    proof: Array<ReadonlyUint8Array>;
    /** Slot the proof was created. */
    creationSlot: number | bigint;
    /** The account that paid for creation of the proof. */
    payer: Address;
};
export declare function getMintProofV2Encoder(): Encoder<MintProofV2Args>;
export declare function getMintProofV2Decoder(): Decoder<MintProofV2>;
export declare function getMintProofV2Codec(): Codec<MintProofV2Args, MintProofV2>;
export declare function decodeMintProofV2<TAddress extends string = string>(encodedAccount: EncodedAccount<TAddress>): Account<MintProofV2, TAddress>;
export declare function decodeMintProofV2<TAddress extends string = string>(encodedAccount: MaybeEncodedAccount<TAddress>): MaybeAccount<MintProofV2, TAddress>;
export declare function fetchMintProofV2<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<Account<MintProofV2, TAddress>>;
export declare function fetchMaybeMintProofV2<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<MaybeAccount<MintProofV2, TAddress>>;
export declare function fetchAllMintProofV2(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<Account<MintProofV2>[]>;
export declare function fetchAllMaybeMintProofV2(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<MaybeAccount<MintProofV2>[]>;
export declare function getMintProofV2Size(): number;
export declare function fetchMintProofV2FromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: MintProofV2Seeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<Account<MintProofV2>>;
export declare function fetchMaybeMintProofV2FromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: MintProofV2Seeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<MaybeAccount<MintProofV2>>;
//# sourceMappingURL=mintProofV2.d.ts.map