/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { fetchEncodedAccount, fetchEncodedAccounts, type Account, type Address, type Codec, type Decoder, type EncodedAccount, type Encoder, type FetchAccountConfig, type FetchAccountsConfig, type MaybeAccount, type MaybeEncodedAccount, type ReadonlyUint8Array } from '@solana/web3.js';
import { WhitelistV2Seeds } from '../pdas';
import { type Condition, type ConditionArgs, type State, type StateArgs } from '../types';
export type WhitelistV2 = {
    discriminator: ReadonlyUint8Array;
    /** Whitelist version, used to control upgrades. */
    version: number;
    /** Bump seed used to derive the PDA. */
    bump: number;
    /** Owner-chosen identifier for the whitelist. */
    uuid: ReadonlyUint8Array;
    /** Whitelist state--currently either Frozen or Unfrozen. */
    state: State;
    /** Authority that can update the whitelist. */
    updateAuthority: Address;
    /** Namespace for the whitelist to further differentiate it from other whitelists owned by the same authority. */
    namespace: Address;
    /** Authority that can freeze/unfreeze the whitelist. */
    freezeAuthority: Address;
    /** Whitelist conditions that must be met to validate against the whitelist. */
    conditions: Array<Condition>;
};
export type WhitelistV2Args = {
    /** Whitelist version, used to control upgrades. */
    version: number;
    /** Bump seed used to derive the PDA. */
    bump: number;
    /** Owner-chosen identifier for the whitelist. */
    uuid: ReadonlyUint8Array;
    /** Whitelist state--currently either Frozen or Unfrozen. */
    state: StateArgs;
    /** Authority that can update the whitelist. */
    updateAuthority: Address;
    /** Namespace for the whitelist to further differentiate it from other whitelists owned by the same authority. */
    namespace: Address;
    /** Authority that can freeze/unfreeze the whitelist. */
    freezeAuthority: Address;
    /** Whitelist conditions that must be met to validate against the whitelist. */
    conditions: Array<ConditionArgs>;
};
export declare function getWhitelistV2Encoder(): Encoder<WhitelistV2Args>;
export declare function getWhitelistV2Decoder(): Decoder<WhitelistV2>;
export declare function getWhitelistV2Codec(): Codec<WhitelistV2Args, WhitelistV2>;
export declare function decodeWhitelistV2<TAddress extends string = string>(encodedAccount: EncodedAccount<TAddress>): Account<WhitelistV2, TAddress>;
export declare function decodeWhitelistV2<TAddress extends string = string>(encodedAccount: MaybeEncodedAccount<TAddress>): MaybeAccount<WhitelistV2, TAddress>;
export declare function fetchWhitelistV2<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<Account<WhitelistV2, TAddress>>;
export declare function fetchMaybeWhitelistV2<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<MaybeAccount<WhitelistV2, TAddress>>;
export declare function fetchAllWhitelistV2(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<Account<WhitelistV2>[]>;
export declare function fetchAllMaybeWhitelistV2(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<MaybeAccount<WhitelistV2>[]>;
export declare function getWhitelistV2Size(): number;
export declare function fetchWhitelistV2FromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: WhitelistV2Seeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<Account<WhitelistV2>>;
export declare function fetchMaybeWhitelistV2FromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: WhitelistV2Seeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<MaybeAccount<WhitelistV2>>;
//# sourceMappingURL=whitelistV2.d.ts.map