/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_WHITELIST_PROGRAM_ADDRESS } from '../programs';
export type CloseMintProofV2Instruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSigner extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableAccount<TAccountPayer> : TAccountPayer,
    TAccountSigner extends string ? WritableSignerAccount<TAccountSigner> & IAccountSignerMeta<TAccountSigner> : TAccountSigner,
    TAccountMintProof extends string ? WritableAccount<TAccountMintProof> : TAccountMintProof,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type CloseMintProofV2InstructionData = {
    discriminator: ReadonlyUint8Array;
};
export type CloseMintProofV2InstructionDataArgs = {};
export declare function getCloseMintProofV2InstructionDataEncoder(): Encoder<CloseMintProofV2InstructionDataArgs>;
export declare function getCloseMintProofV2InstructionDataDecoder(): Decoder<CloseMintProofV2InstructionData>;
export declare function getCloseMintProofV2InstructionDataCodec(): Codec<CloseMintProofV2InstructionDataArgs, CloseMintProofV2InstructionData>;
export type CloseMintProofV2Input<TAccountPayer extends string = string, TAccountSigner extends string = string, TAccountMintProof extends string = string, TAccountSystemProgram extends string = string> = {
    /** Receives rent if < 100 slots after mint_proof creation. */
    payer: Address<TAccountPayer>;
    /** Signing account, will receive rent if > 100 slots after mint_proof creation. */
    signer: TransactionSigner<TAccountSigner>;
    /** The mint proof account to close. */
    mintProof: Address<TAccountMintProof>;
    /** The Solana system program account. */
    systemProgram?: Address<TAccountSystemProgram>;
};
export declare function getCloseMintProofV2Instruction<TAccountPayer extends string, TAccountSigner extends string, TAccountMintProof extends string, TAccountSystemProgram extends string>(input: CloseMintProofV2Input<TAccountPayer, TAccountSigner, TAccountMintProof, TAccountSystemProgram>): CloseMintProofV2Instruction<typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountPayer, TAccountSigner, TAccountMintProof, TAccountSystemProgram>;
export type ParsedCloseMintProofV2Instruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Receives rent if < 100 slots after mint_proof creation. */
        payer: TAccountMetas[0];
        /** Signing account, will receive rent if > 100 slots after mint_proof creation. */
        signer: TAccountMetas[1];
        /** The mint proof account to close. */
        mintProof: TAccountMetas[2];
        /** The Solana system program account. */
        systemProgram: TAccountMetas[3];
    };
    data: CloseMintProofV2InstructionData;
};
export declare function parseCloseMintProofV2Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCloseMintProofV2Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=closeMintProofV2.d.ts.map