/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_WHITELIST_PROGRAM_ADDRESS } from '../programs';
import { type Condition, type ConditionArgs } from '../types';
export type CreateWhitelistV2Instruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountNamespace extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountUpdateAuthority extends string ? WritableSignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountNamespace extends string ? ReadonlySignerAccount<TAccountNamespace> & IAccountSignerMeta<TAccountNamespace> : TAccountNamespace,
    TAccountWhitelist extends string ? WritableAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type CreateWhitelistV2InstructionData = {
    discriminator: ReadonlyUint8Array;
    uuid: ReadonlyUint8Array;
    freezeAuthority: Option<Address>;
    conditions: Array<Condition>;
};
export type CreateWhitelistV2InstructionDataArgs = {
    uuid: ReadonlyUint8Array;
    freezeAuthority: OptionOrNullable<Address>;
    conditions: Array<ConditionArgs>;
};
export declare function getCreateWhitelistV2InstructionDataEncoder(): Encoder<CreateWhitelistV2InstructionDataArgs>;
export declare function getCreateWhitelistV2InstructionDataDecoder(): Decoder<CreateWhitelistV2InstructionData>;
export declare function getCreateWhitelistV2InstructionDataCodec(): Codec<CreateWhitelistV2InstructionDataArgs, CreateWhitelistV2InstructionData>;
export type CreateWhitelistV2AsyncInput<TAccountPayer extends string = string, TAccountUpdateAuthority extends string = string, TAccountNamespace extends string = string, TAccountWhitelist extends string = string, TAccountSystemProgram extends string = string> = {
    /** The rent payer. */
    payer: TransactionSigner<TAccountPayer>;
    /** The authority that will be allowed to update the whitelist. */
    updateAuthority: TransactionSigner<TAccountUpdateAuthority>;
    /** Namespace keypair used to derive the whitelist PDA. */
    namespace: TransactionSigner<TAccountNamespace>;
    /** The whitelist PDA. */
    whitelist?: Address<TAccountWhitelist>;
    systemProgram?: Address<TAccountSystemProgram>;
    uuid: CreateWhitelistV2InstructionDataArgs['uuid'];
    freezeAuthority: CreateWhitelistV2InstructionDataArgs['freezeAuthority'];
    conditions: CreateWhitelistV2InstructionDataArgs['conditions'];
};
export declare function getCreateWhitelistV2InstructionAsync<TAccountPayer extends string, TAccountUpdateAuthority extends string, TAccountNamespace extends string, TAccountWhitelist extends string, TAccountSystemProgram extends string>(input: CreateWhitelistV2AsyncInput<TAccountPayer, TAccountUpdateAuthority, TAccountNamespace, TAccountWhitelist, TAccountSystemProgram>): Promise<CreateWhitelistV2Instruction<typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountPayer, TAccountUpdateAuthority, TAccountNamespace, TAccountWhitelist, TAccountSystemProgram>>;
export type CreateWhitelistV2Input<TAccountPayer extends string = string, TAccountUpdateAuthority extends string = string, TAccountNamespace extends string = string, TAccountWhitelist extends string = string, TAccountSystemProgram extends string = string> = {
    /** The rent payer. */
    payer: TransactionSigner<TAccountPayer>;
    /** The authority that will be allowed to update the whitelist. */
    updateAuthority: TransactionSigner<TAccountUpdateAuthority>;
    /** Namespace keypair used to derive the whitelist PDA. */
    namespace: TransactionSigner<TAccountNamespace>;
    /** The whitelist PDA. */
    whitelist: Address<TAccountWhitelist>;
    systemProgram?: Address<TAccountSystemProgram>;
    uuid: CreateWhitelistV2InstructionDataArgs['uuid'];
    freezeAuthority: CreateWhitelistV2InstructionDataArgs['freezeAuthority'];
    conditions: CreateWhitelistV2InstructionDataArgs['conditions'];
};
export declare function getCreateWhitelistV2Instruction<TAccountPayer extends string, TAccountUpdateAuthority extends string, TAccountNamespace extends string, TAccountWhitelist extends string, TAccountSystemProgram extends string>(input: CreateWhitelistV2Input<TAccountPayer, TAccountUpdateAuthority, TAccountNamespace, TAccountWhitelist, TAccountSystemProgram>): CreateWhitelistV2Instruction<typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountPayer, TAccountUpdateAuthority, TAccountNamespace, TAccountWhitelist, TAccountSystemProgram>;
export type ParsedCreateWhitelistV2Instruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The rent payer. */
        payer: TAccountMetas[0];
        /** The authority that will be allowed to update the whitelist. */
        updateAuthority: TAccountMetas[1];
        /** Namespace keypair used to derive the whitelist PDA. */
        namespace: TAccountMetas[2];
        /** The whitelist PDA. */
        whitelist: TAccountMetas[3];
        systemProgram: TAccountMetas[4];
    };
    data: CreateWhitelistV2InstructionData;
};
export declare function parseCreateWhitelistV2Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateWhitelistV2Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createWhitelistV2.d.ts.map