/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_WHITELIST_PROGRAM_ADDRESS } from '../programs';
export type InitUpdateMintProofV2Instruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountMintProof extends string ? WritableAccount<TAccountMintProof> : TAccountMintProof,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type InitUpdateMintProofV2InstructionData = {
    discriminator: ReadonlyUint8Array;
    proof: Array<ReadonlyUint8Array>;
};
export type InitUpdateMintProofV2InstructionDataArgs = {
    proof: Array<ReadonlyUint8Array>;
};
export declare function getInitUpdateMintProofV2InstructionDataEncoder(): Encoder<InitUpdateMintProofV2InstructionDataArgs>;
export declare function getInitUpdateMintProofV2InstructionDataDecoder(): Decoder<InitUpdateMintProofV2InstructionData>;
export declare function getInitUpdateMintProofV2InstructionDataCodec(): Codec<InitUpdateMintProofV2InstructionDataArgs, InitUpdateMintProofV2InstructionData>;
export type InitUpdateMintProofV2AsyncInput<TAccountPayer extends string = string, TAccountMint extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountSystemProgram extends string = string> = {
    /** Rent payer for the mint proof account if it is initialized. */
    payer: TransactionSigner<TAccountPayer>;
    /** The mint account for which the proof is being created. */
    mint: Address<TAccountMint>;
    /** The whitelist account that the mint proof must validate against. */
    whitelist: Address<TAccountWhitelist>;
    /** The mint proof account to initialize or update. */
    mintProof?: Address<TAccountMintProof>;
    /** The Solana system program account. */
    systemProgram?: Address<TAccountSystemProgram>;
    proof: InitUpdateMintProofV2InstructionDataArgs['proof'];
};
export declare function getInitUpdateMintProofV2InstructionAsync<TAccountPayer extends string, TAccountMint extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountSystemProgram extends string>(input: InitUpdateMintProofV2AsyncInput<TAccountPayer, TAccountMint, TAccountWhitelist, TAccountMintProof, TAccountSystemProgram>): Promise<InitUpdateMintProofV2Instruction<typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountPayer, TAccountMint, TAccountWhitelist, TAccountMintProof, TAccountSystemProgram>>;
export type InitUpdateMintProofV2Input<TAccountPayer extends string = string, TAccountMint extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountSystemProgram extends string = string> = {
    /** Rent payer for the mint proof account if it is initialized. */
    payer: TransactionSigner<TAccountPayer>;
    /** The mint account for which the proof is being created. */
    mint: Address<TAccountMint>;
    /** The whitelist account that the mint proof must validate against. */
    whitelist: Address<TAccountWhitelist>;
    /** The mint proof account to initialize or update. */
    mintProof: Address<TAccountMintProof>;
    /** The Solana system program account. */
    systemProgram?: Address<TAccountSystemProgram>;
    proof: InitUpdateMintProofV2InstructionDataArgs['proof'];
};
export declare function getInitUpdateMintProofV2Instruction<TAccountPayer extends string, TAccountMint extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountSystemProgram extends string>(input: InitUpdateMintProofV2Input<TAccountPayer, TAccountMint, TAccountWhitelist, TAccountMintProof, TAccountSystemProgram>): InitUpdateMintProofV2Instruction<typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountPayer, TAccountMint, TAccountWhitelist, TAccountMintProof, TAccountSystemProgram>;
export type ParsedInitUpdateMintProofV2Instruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Rent payer for the mint proof account if it is initialized. */
        payer: TAccountMetas[0];
        /** The mint account for which the proof is being created. */
        mint: TAccountMetas[1];
        /** The whitelist account that the mint proof must validate against. */
        whitelist: TAccountMetas[2];
        /** The mint proof account to initialize or update. */
        mintProof: TAccountMetas[3];
        /** The Solana system program account. */
        systemProgram: TAccountMetas[4];
    };
    data: InitUpdateMintProofV2InstructionData;
};
export declare function parseInitUpdateMintProofV2Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedInitUpdateMintProofV2Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=initUpdateMintProofV2.d.ts.map