/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_WHITELIST_PROGRAM_ADDRESS } from '../programs';
export type InitUpdateWhitelistInstruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountWhitelistAuthority extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountWhitelist extends string ? WritableAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountWhitelistAuthority extends string ? ReadonlyAccount<TAccountWhitelistAuthority> : TAccountWhitelistAuthority,
    TAccountCosigner extends string ? WritableSignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type InitUpdateWhitelistInstructionData = {
    discriminator: ReadonlyUint8Array;
    uuid: ReadonlyUint8Array;
    rootHash: Option<ReadonlyUint8Array>;
    name: Option<ReadonlyUint8Array>;
    voc: Option<Address>;
    fvc: Option<Address>;
};
export type InitUpdateWhitelistInstructionDataArgs = {
    uuid: ReadonlyUint8Array;
    rootHash: OptionOrNullable<ReadonlyUint8Array>;
    name: OptionOrNullable<ReadonlyUint8Array>;
    voc: OptionOrNullable<Address>;
    fvc: OptionOrNullable<Address>;
};
export declare function getInitUpdateWhitelistInstructionDataEncoder(): Encoder<InitUpdateWhitelistInstructionDataArgs>;
export declare function getInitUpdateWhitelistInstructionDataDecoder(): Decoder<InitUpdateWhitelistInstructionData>;
export declare function getInitUpdateWhitelistInstructionDataCodec(): Codec<InitUpdateWhitelistInstructionDataArgs, InitUpdateWhitelistInstructionData>;
export type InitUpdateWhitelistAsyncInput<TAccountWhitelist extends string = string, TAccountWhitelistAuthority extends string = string, TAccountCosigner extends string = string, TAccountSystemProgram extends string = string> = {
    whitelist?: Address<TAccountWhitelist>;
    /**
     * there can only be 1 whitelist authority (due to seeds),
     * and we're checking that 1)the correct cosigner is present on it, and 2)is a signer
     */
    whitelistAuthority?: Address<TAccountWhitelistAuthority>;
    /** only cosigner has to sign for unfrozen, for frozen owner also has to sign */
    cosigner: TransactionSigner<TAccountCosigner>;
    systemProgram?: Address<TAccountSystemProgram>;
    uuid: InitUpdateWhitelistInstructionDataArgs['uuid'];
    rootHash: InitUpdateWhitelistInstructionDataArgs['rootHash'];
    name: InitUpdateWhitelistInstructionDataArgs['name'];
    voc: InitUpdateWhitelistInstructionDataArgs['voc'];
    fvc: InitUpdateWhitelistInstructionDataArgs['fvc'];
};
export declare function getInitUpdateWhitelistInstructionAsync<TAccountWhitelist extends string, TAccountWhitelistAuthority extends string, TAccountCosigner extends string, TAccountSystemProgram extends string>(input: InitUpdateWhitelistAsyncInput<TAccountWhitelist, TAccountWhitelistAuthority, TAccountCosigner, TAccountSystemProgram>): Promise<InitUpdateWhitelistInstruction<typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountWhitelist, TAccountWhitelistAuthority, TAccountCosigner, TAccountSystemProgram>>;
export type InitUpdateWhitelistInput<TAccountWhitelist extends string = string, TAccountWhitelistAuthority extends string = string, TAccountCosigner extends string = string, TAccountSystemProgram extends string = string> = {
    whitelist: Address<TAccountWhitelist>;
    /**
     * there can only be 1 whitelist authority (due to seeds),
     * and we're checking that 1)the correct cosigner is present on it, and 2)is a signer
     */
    whitelistAuthority: Address<TAccountWhitelistAuthority>;
    /** only cosigner has to sign for unfrozen, for frozen owner also has to sign */
    cosigner: TransactionSigner<TAccountCosigner>;
    systemProgram?: Address<TAccountSystemProgram>;
    uuid: InitUpdateWhitelistInstructionDataArgs['uuid'];
    rootHash: InitUpdateWhitelistInstructionDataArgs['rootHash'];
    name: InitUpdateWhitelistInstructionDataArgs['name'];
    voc: InitUpdateWhitelistInstructionDataArgs['voc'];
    fvc: InitUpdateWhitelistInstructionDataArgs['fvc'];
};
export declare function getInitUpdateWhitelistInstruction<TAccountWhitelist extends string, TAccountWhitelistAuthority extends string, TAccountCosigner extends string, TAccountSystemProgram extends string>(input: InitUpdateWhitelistInput<TAccountWhitelist, TAccountWhitelistAuthority, TAccountCosigner, TAccountSystemProgram>): InitUpdateWhitelistInstruction<typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountWhitelist, TAccountWhitelistAuthority, TAccountCosigner, TAccountSystemProgram>;
export type ParsedInitUpdateWhitelistInstruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        whitelist: TAccountMetas[0];
        /**
         * there can only be 1 whitelist authority (due to seeds),
         * and we're checking that 1)the correct cosigner is present on it, and 2)is a signer
         */
        whitelistAuthority: TAccountMetas[1];
        /** only cosigner has to sign for unfrozen, for frozen owner also has to sign */
        cosigner: TAccountMetas[2];
        systemProgram: TAccountMetas[3];
    };
    data: InitUpdateWhitelistInstructionData;
};
export declare function parseInitUpdateWhitelistInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedInitUpdateWhitelistInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=initUpdateWhitelist.d.ts.map