/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_WHITELIST_PROGRAM_ADDRESS } from '../programs';
import { type Condition, type ConditionArgs, type Operation, type OperationArgs } from '../types';
export type UpdateWhitelistV2Instruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountNewUpdateAuthority extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountUpdateAuthority extends string ? WritableSignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountNewUpdateAuthority extends string ? ReadonlySignerAccount<TAccountNewUpdateAuthority> & IAccountSignerMeta<TAccountNewUpdateAuthority> : TAccountNewUpdateAuthority,
    TAccountWhitelist extends string ? WritableAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type UpdateWhitelistV2InstructionData = {
    discriminator: ReadonlyUint8Array;
    freezeAuthority: Operation;
    conditions: Option<Array<Condition>>;
};
export type UpdateWhitelistV2InstructionDataArgs = {
    freezeAuthority: OperationArgs;
    conditions: OptionOrNullable<Array<ConditionArgs>>;
};
export declare function getUpdateWhitelistV2InstructionDataEncoder(): Encoder<UpdateWhitelistV2InstructionDataArgs>;
export declare function getUpdateWhitelistV2InstructionDataDecoder(): Decoder<UpdateWhitelistV2InstructionData>;
export declare function getUpdateWhitelistV2InstructionDataCodec(): Codec<UpdateWhitelistV2InstructionDataArgs, UpdateWhitelistV2InstructionData>;
export type UpdateWhitelistV2Input<TAccountPayer extends string = string, TAccountUpdateAuthority extends string = string, TAccountNewUpdateAuthority extends string = string, TAccountWhitelist extends string = string, TAccountSystemProgram extends string = string> = {
    /** Rent payer if reallocating the WhitelistV2 account to include more conditions. */
    payer: TransactionSigner<TAccountPayer>;
    /** The current update authority. */
    updateAuthority: TransactionSigner<TAccountUpdateAuthority>;
    newUpdateAuthority?: TransactionSigner<TAccountNewUpdateAuthority>;
    /** The WhitelistV2 account to update. */
    whitelist: Address<TAccountWhitelist>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    freezeAuthority: UpdateWhitelistV2InstructionDataArgs['freezeAuthority'];
    conditions: UpdateWhitelistV2InstructionDataArgs['conditions'];
};
export declare function getUpdateWhitelistV2Instruction<TAccountPayer extends string, TAccountUpdateAuthority extends string, TAccountNewUpdateAuthority extends string, TAccountWhitelist extends string, TAccountSystemProgram extends string>(input: UpdateWhitelistV2Input<TAccountPayer, TAccountUpdateAuthority, TAccountNewUpdateAuthority, TAccountWhitelist, TAccountSystemProgram>): UpdateWhitelistV2Instruction<typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountPayer, TAccountUpdateAuthority, TAccountNewUpdateAuthority, TAccountWhitelist, TAccountSystemProgram>;
export type ParsedUpdateWhitelistV2Instruction<TProgram extends string = typeof TENSOR_WHITELIST_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Rent payer if reallocating the WhitelistV2 account to include more conditions. */
        payer: TAccountMetas[0];
        /** The current update authority. */
        updateAuthority: TAccountMetas[1];
        newUpdateAuthority?: TAccountMetas[2] | undefined;
        /** The WhitelistV2 account to update. */
        whitelist: TAccountMetas[3];
        /** The Solana system program. */
        systemProgram: TAccountMetas[4];
    };
    data: UpdateWhitelistV2InstructionData;
};
export declare function parseUpdateWhitelistV2Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUpdateWhitelistV2Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=updateWhitelistV2.d.ts.map